﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Data
Imports MySql.Data.MySqlClient
Imports System.Configuration
Imports System.ComponentModel

<DataObject(True)> _
Public NotInheritable Class acessoBD
    Private Sub New()
    End Sub

    Private Shared Function GetConnectionString() As String
        Return ConfigurationManager.ConnectionStrings("MySQLConnectionString").ConnectionString
    End Function

    <DataObjectMethod(DataObjectMethodType.[Select])> _
Public Shared Function GetMensagems() As List(Of MensagemItem)
        Dim cmd As New MySqlCommand("sp_ListaMensagens", New MySqlConnection(GetConnectionString()))
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Connection.Open()
        Dim dr As MySqlDataReader = cmd.ExecuteReader(CommandBehavior.CloseConnection)

        Dim MensagemItemlist As New List(Of MensagemItem)()
        While dr.Read()
            Dim MensagemItem As New MensagemItem()
            MensagemItem.Codigo = Convert.ToInt32(dr("Codigo"))
            MensagemItem.Mensagem = Convert.ToString(dr("Mensagem"))
            MensagemItem.Nome = Convert.ToString(dr("Nome"))
            MensagemItem.Email = Convert.ToString(dr("Email"))
            MensagemItemlist.Add(MensagemItem)
        End While
        dr.Close()
        Return MensagemItemlist
    End Function

    <DataObjectMethod(DataObjectMethodType.Insert)> _
Public Shared Sub InsertMensagem(ByVal MensagemItem As MensagemItem)
        Dim cmd As New MySqlCommand("sp_InserirMensagem", New MySqlConnection(GetConnectionString()))
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.Add(New MySqlParameter("param1", MensagemItem.Nome))
        cmd.Parameters.Add(New MySqlParameter("param2", MensagemItem.Email))
        cmd.Parameters.Add(New MySqlParameter("param3", MensagemItem.Mensagem))
        cmd.Connection.Open()
        cmd.ExecuteNonQuery()
        cmd.Connection.Close()
    End Sub

    <DataObjectMethod(DataObjectMethodType.Update)> _
Public Shared Function UpdateMensagem(ByVal MensagemItem As MensagemItem) As Integer
        Dim cmd As New MySqlCommand("sp_AtualizarMensagem", New MySqlConnection(GetConnectionString()))
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.Add(New MySqlParameter("paramkey", MensagemItem.Codigo))
        cmd.Parameters.Add(New MySqlParameter("param1", MensagemItem.Nome))
        cmd.Parameters.Add(New MySqlParameter("param2", MensagemItem.Email))
        cmd.Parameters.Add(New MySqlParameter("param3", MensagemItem.Mensagem))
        cmd.Connection.Open()
        Dim i As Integer = cmd.ExecuteNonQuery()
        cmd.Connection.Close()
        Return i
    End Function

    <DataObjectMethod(DataObjectMethodType.Delete)> _
Public Shared Function DeleteMensagem(ByVal MensagemItem As MensagemItem) As Integer
        Dim cmd As New MySqlCommand("sp_DeletarMensagem", New MySqlConnection(GetConnectionString()))
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.Add(New MySqlParameter("paramKey", MensagemItem.Codigo))
        cmd.Connection.Open()
        Dim i As Integer = cmd.ExecuteNonQuery()
        cmd.Connection.Close()
        Return i
    End Function
End Class
